/*
hprime.c Version 0.2.0  Hash calculate prime number
Copyright (C) 2003-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <math.h>

int hprime(maxnum)
int maxnum;
   {
   int i;
   int num;
   int root;
   if (maxnum < 1 || maxnum > 999999999)
      {
      fprintf(stderr,"hprime: number "
	 "%d out of range\n", maxnum);
      return(-1);
      }
   num = maxnum;
   if (num == 1 || num == 2)
      {
      return(num);
      } /* if 1 or 2 */
   if (!(num & 1)) num--;
   root = (int) sqrt((double) num);
   while (num > 3)
      {
      i = 3;
      while (i <= root)
	 {
	 if (!(num % i)) break;
	 i += 2;
	 } /* for each factor */
      if (i > root) break;
      num -= 2;
      } /* for each candidate number */
   return(num);
   } /* hprime */
